
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/* Copyright (C) 2000 by Andreas Kemnade     akemnade@t-online.de */

#include <windows.h>
#include <windowsx.h>
#include <process.h>
#include "wincivgo.h"
struct scroll_data Start_Scr[]={
  {80,40,200,"set xsize %d",ID_START_MWIDTH},
  {50,25,100,"set ysize %d",ID_START_MHEIGHT},
  {50,0,500,"set huts %d",ID_START_HUTS},
  {50,0,5000,"set gold %d",ID_START_GOLD},
  {3,0,50,"set techlevel %d",ID_START_ADVANCES},
  {4,1,6,"set unhappysize %d",ID_START_UNHAPPY},
  {4,0,30,"set aifill %d",ID_START_AIFILL},
  {2,1,10,"set settlers %d",ID_START_SETTLER},
  {1,0,10,"set explorer %d",ID_START_EXPLORER},
  {0,0,10,"set dispersion %d",ID_START_UNIT},
  {10,4,100,"set researchspeed %d",ID_START_PADVANCE},
  {10,5,30,"set foodbox %d",ID_START_GROW},
  {30,15,85,"set landmass %d",ID_START_LAND},
  {50,0,1000,"set rivers %d",ID_START_RIVER},
  {250,0,1000,"set specials %d",ID_START_SPECIAL},
  {30,10,100,"set mountains %d",ID_START_HILLS},
  {20,0,100,"set forests %d",ID_START_FOREST},
  {35,20,100,"set grass %d",ID_START_GRASS},
  {5,0,100,"set swamps %d",ID_START_SWAMP},
  {5,0,100,"set deserts %d",ID_START_DESERT},
  {0,0,0,NULL,0}
};
struct scroll_data Run_Scr[]={
  {2,0,4,"set barbarians %d",ID_RUN_BARBARIAN},
  {-2000,-4000,5000,"set onsetbarbs %d",ID_RUN_ONSET},
  {80,1,99,"set diplchance %d",ID_RUN_SPY},
  {2000,-4000,5000,"set endyear %d",ID_RUN_END},
  {10,6,1000,"set civilwarsize %d",ID_RUN_CIVIL},
  {0,0,0,NULL,0}
};
HINSTANCE hInst;
void SendPipeStr(char *s);
static HANDLE stdoutR;
static HANDLE stdoutW;
HANDLE stdinR;
HANDLE stdinW;
HANDLE stderrR;
HANDLE stderrW;
HANDLE mythread=INVALID_HANDLE_VALUE; 
static HWND hServerOut;
PROCESS_INFORMATION server_proc;
void terminate_server();

int start_new_server(char *gameload)
{
  STARTUPINFO si;
  PROCESS_INFORMATION pi;
  char cmdline[500];
  ZeroMemory(&si,sizeof(si));
  si.cb=sizeof(si);
  si.hStdOutput=stdoutW;
  si.hStdInput=stdinR;
  si.hStdError=stderrW;
  si.dwFlags=STARTF_USESTDHANDLES;
  terminate_server();
  if (!gameload)
    {
      strcpy(cmdline,"civserver");
    }
  else
    {
      sprintf(cmdline,"civserver -f \"%s\"",gameload);
    }
  if (!CreateProcess(NULL,cmdline,NULL,NULL,TRUE,NORMAL_PRIORITY_CLASS,
		    NULL,NULL,&si,&pi))
    {
      MessageBox(NULL,"Cannot start the server","Freeciv",MB_OK|MB_ICONEXCLAMATION);
      return 0;
    }
  else
    {
      server_proc.hProcess=pi.hProcess;
      server_proc.hThread=pi.hThread;
      /* This differs from the server defaults 
	 It would take too much time to set everything now */
      if (!gameload) SendPipeStr("set aifill 4\n");
      return 1;
    }
}
int start_client()
{
  STARTUPINFO si;
  PROCESS_INFORMATION pi;
  ZeroMemory(&si,sizeof(si));
  si.cb=sizeof(si);
  if (CreateProcess(NULL,"civclient",NULL,NULL,TRUE,NORMAL_PRIORITY_CLASS,
		    NULL,NULL,&si,&pi))
    {
      CloseHandle(pi.hProcess);
      CloseHandle(pi.hThread);
      return 1;
    }
  return 0;
}
void load_game(HWND hWnd)
{
  OPENFILENAME ofn;
  TCHAR szfile[MAX_PATH]="\0";
  strcpy(szfile,"");
  ofn.lStructSize=sizeof(OPENFILENAME);
  ofn.hwndOwner=hWnd;
  ofn.hInstance=hInst;
  ofn.lpstrFilter=NULL;
  ofn.lpstrCustomFilter=NULL;
  ofn.nMaxCustFilter=0;
  ofn.nFilterIndex=1;
  ofn.lpstrFile=szfile;
  ofn.nMaxFile=sizeof(szfile);
  ofn.lpstrFileTitle=NULL;
  ofn.nMaxFileTitle=0;
  ofn.lpstrInitialDir=NULL;
  ofn.lpstrTitle="Load Game";
  ofn.nFileOffset=0;
  ofn.nFileExtension=0;
  ofn.lpstrDefExt=NULL;
  ofn.lCustData=0;
  ofn.lpfnHook=NULL;
  ofn.lpTemplateName=NULL;
  ofn.Flags=OFN_EXPLORER;
  if (GetOpenFileName(&ofn))
    {
      if (start_new_server(ofn.lpstrFile))
	{
	  EnableWindow(GetDlgItem(hWnd,ID_MAIN_SAVE),TRUE);
	  EnableWindow(GetDlgItem(hWnd,ID_MAIN_START),TRUE);
	  EnableWindow(GetDlgItem(hWnd,ID_MAIN_START_OPT),TRUE);
	  EnableWindow(GetDlgItem(hWnd,ID_MAIN_RUN_OPT),TRUE);
	}                   
    }
}
void save_game(HWND hWnd)
{
  OPENFILENAME ofn;
  char savecmd[MAX_PATH+10];
  char szfile[MAX_PATH]="\0";
  strcpy(szfile,"");
  ofn.lStructSize=sizeof(OPENFILENAME);
  ofn.hwndOwner=hWnd;
  ofn.hInstance=hInst;
  ofn.lpstrFilter=NULL;
  ofn.lpstrCustomFilter=NULL;
  ofn.nMaxCustFilter=0;
  ofn.nFilterIndex=1;
  ofn.lpstrFile=szfile;
  ofn.nMaxFile=sizeof(szfile);
  ofn.lpstrFileTitle=NULL;
  ofn.nMaxFileTitle=0;
  ofn.lpstrInitialDir=NULL;
  ofn.lpstrTitle="Save Game";
  ofn.nFileOffset=0;
  ofn.nFileExtension=0;
  ofn.lpstrDefExt=NULL;
  ofn.lCustData=0;
  ofn.lpfnHook=NULL;
  ofn.lpTemplateName=NULL;
  ofn.Flags=OFN_EXPLORER;
  if (GetOpenFileName(&ofn))
    {
      sprintf(savecmd,"save %s\n",ofn.lpstrFile);
      SendPipeStr(savecmd);
    }    
}
void handle_pipe()
{
  char buf[800];
  DWORD rlen;
  int len;
  while (1)
    {
#if 0
      if (WaitForSingleObject(stdoutR,INFINITE)==WAIT_OBJECT_0)
#endif
	{
	  if (ReadFile(stdoutR,buf,800,&rlen,NULL))
	    {
	      buf[rlen]=0;
	      printf("rlen: %d",rlen);
	      printf(buf);
	      len=Edit_GetTextLength(hServerOut);
	      if (len>30000)
		{
		  Edit_SetSel(hServerOut,0,len);
		}
	      else
		{
		  Edit_SetSel(hServerOut,len,len);
		}
	      Edit_ReplaceSel(hServerOut,buf);
	    }
	}
    }
}
void init_win_pipe()
{
  DWORD threadid;
  mythread=_beginthreadex(NULL,0,handle_pipe,NULL,0,&threadid);   
}
void SendPipeStr(char *s)
{
  DWORD wlen;
  WriteFile(stdinW,s,strlen(s),&wlen,NULL);
}
void Handle_Scroll(struct scroll_data *scr_data,int id,int pos)
{
  int i;
  char buf[80];
  DWORD wlen;
  i=0;
  printf("Scroll\n");
  while(scr_data[i].id)
    {
      if (scr_data[i].id==id)
	{
	  sprintf(buf,scr_data[i].serverfmt,pos);
	  strcat(buf,"\n");
	  WriteFile(stdinW,buf,strlen(buf),&wlen,NULL);
	}
      i++;
    }
}

void Handle_Hscroll(struct scroll_data *scr_data,HWND hWnd,HWND hWndCtl,UINT code,int pos)
{
  char buf[10];
  int PosCur,PosMax,PosMin,id;
  PosCur=ScrollBar_GetPos(hWndCtl);
  ScrollBar_GetRange(hWndCtl,&PosMin,&PosMax);
  switch(code)
    {
    case SB_LINELEFT: PosCur--; break;
    case SB_LINERIGHT: PosCur++; break;
    case SB_PAGELEFT: PosCur-=(PosMax-PosMin+1)/10; break;
    case SB_PAGERIGHT: PosCur+=(PosMax-PosMin+1)/10; break;
    case SB_LEFT: PosCur=PosMin; break;
    case SB_RIGHT: PosCur=PosMax; break;
    case SB_THUMBTRACK: PosCur=pos; break;
    case SB_THUMBPOSITION: 
    case SB_ENDSCROLL: 
      id=GetDlgCtrlID(hWndCtl);
      Handle_Scroll(scr_data,id,PosCur);
      break;
    }
  if (PosCur<PosMin) PosCur=PosMin;
  if (PosCur>PosMax) PosCur=PosMax;
  ScrollBar_SetPos(hWndCtl,PosCur,TRUE);
  sprintf(buf,"%d",PosCur);
  SetWindowText(GetPrevSibling(hWndCtl),buf);
}
void Handle_St_Hscroll(HWND hWnd,HWND hWndCtl,UINT code,int pos)
{
  Handle_Hscroll(&Start_Scr[0],hWnd,hWndCtl,code,pos);
}
void Handle_Run_Hscroll(HWND hWnd,HWND hWndCtl,UINT code,int pos)
{
  Handle_Hscroll(&Run_Scr[0],hWnd,hWndCtl,code,pos);
}

void init_start_scr(struct scroll_data *scr_data,HWND hWnd)
{
  int i;
  i=0;
  while(scr_data[i].id)
    {
      ScrollBar_SetRange(GetDlgItem(hWnd,scr_data[i].id),
			 scr_data[i].min,scr_data[i].max,TRUE);
      ScrollBar_SetPos(GetDlgItem(hWnd,scr_data[i].id),
		       scr_data[i].defaultpos,TRUE);
      FORWARD_WM_HSCROLL(hWnd,GetDlgItem(hWnd,scr_data[i].id),SB_THUMBTRACK,
			 scr_data[i].defaultpos,SendMessage);
      i++;
    }
}

void terminate_server()
{
  if (server_proc.hProcess==INVALID_HANDLE_VALUE)
    return;
  printf("Terminate\n");
  SendPipeStr("quit\n");
  Sleep(3000);
  if (WaitForSingleObject(server_proc.hProcess,0)!=WAIT_OBJECT_0)
    TerminateProcess(server_proc.hProcess,0);
  CloseHandle(server_proc.hProcess);
  CloseHandle(server_proc.hThread);
  server_proc.hProcess=INVALID_HANDLE_VALUE;
}
BOOL CALLBACK RunDlg_Proc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  switch (uMsg)
    {
    case WM_INITDIALOG:
      init_start_scr(&Run_Scr[0],hWnd);
      break;
    case WM_COMMAND:
      switch(LOWORD(wParam))
	{
	case ID_RUN_SPACEON: SendPipeStr("set spacerace 1\n"); break;
	case ID_RUN_SPACEOFF: SendPipeStr("set spacerace 0\n"); break;
	case ID_RUN_FOGOFF: SendPipeStr("set fogofwar 0\n"); break;
	case ID_RUN_FOGON: SendPipeStr("set fogofwar 1\n"); break;
	case ID_RUN_EASY: SendPipeStr("easy\n"); break;
	case ID_RUN_NORMAL: SendPipeStr("normal\n"); break;
	case ID_RUN_HARD: SendPipeStr("hard\n"); break;
     
	case IDCANCEL:
	  EndDialog(hWnd,wParam);
	  break;
	}
      break;
    case WM_HSCROLL:
      HANDLE_WM_HSCROLL(hWnd,wParam,lParam,Handle_Run_Hscroll);
      break;
    }
  return FALSE;
}
BOOL CALLBACK StartDlg_Proc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  switch (uMsg)
    {
    case WM_INITDIALOG:
      init_start_scr(&Start_Scr[0],hWnd);
      break;
    case WM_COMMAND:
      switch(LOWORD(wParam))
	{
	case ID_START_ONE:
	  SendPipeStr("set civstyle 1\n");
	  break;
	case ID_START_TWO:
	  SendPipeStr("set civstyle 2\n");
	  break;
	case ID_START_MAP_STANDARD:
	  SendPipeStr("set generator 1\n");
	  break;
	case ID_START_MAP_LARGE_ISLANDS:
	  SendPipeStr("set generator 2\n");
	  break;
	case ID_START_MAP_ISLANDS:
	  SendPipeStr("set generator 3\n");
	  break;
	case ID_START_MAP_LARGE_ISLANDS2:
	  SendPipeStr("set generator 4\n");
	  break;
	case IDCANCEL:
	  EndDialog(hWnd,wParam);
	  break;
	default:
	  printf("wParam: %d\n",LOWORD(wParam));
	  break;
	  
	}
      break;
    case WM_HSCROLL:
      HANDLE_WM_HSCROLL(hWnd,wParam,lParam,Handle_St_Hscroll);
      break;
    }
  return FALSE;
}
BOOL CALLBACK About_Proc(HWND hdlg,UINT uMsg, WPARAM wParam,LPARAM lParam)
{
  switch (uMsg)
    {
    case WM_INITDIALOG:
      return(TRUE);
    case WM_COMMAND:
      EndDialog(hdlg,0);
      return TRUE;
      break;
    }
  return FALSE;
}     
BOOL CALLBACK Dlg_Proc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  char inp_buf[100];
  DWORD ret_len;
  switch (uMsg)
    {
    case WM_INITDIALOG:
      hServerOut=GetDlgItem(hWnd,ID_MAIN_SERVER_OUT);
      init_win_pipe();
      break;
    case WM_COMMAND:
      switch(LOWORD(wParam))
	{
	case IDCANCEL:
	case ID_MAIN_QUIT:
	  EndDialog(hWnd,wParam);
	  break;
	case ID_MAIN_NEW:
	  if (start_new_server(NULL))
	    {
	      EnableWindow(GetDlgItem(hWnd,ID_MAIN_SAVE),TRUE);
	      EnableWindow(GetDlgItem(hWnd,ID_MAIN_START),TRUE);
	      EnableWindow(GetDlgItem(hWnd,ID_MAIN_START_OPT),TRUE);
	      EnableWindow(GetDlgItem(hWnd,ID_MAIN_RUN_OPT),TRUE);
	    }
	  break;
	case ID_MAIN_START_OPT:
	  DialogBox(hInst,MAKEINTRESOURCE(ID_STARTOPTIONS),NULL,StartDlg_Proc);
	  break;
	case ID_MAIN_RUN_OPT:
	  DialogBox(hInst,MAKEINTRESOURCE(ID_RUN_DLG),NULL,RunDlg_Proc);
	  break;
	case ID_MAIN_LOAD:
	  load_game(hWnd);
	  break;
	case ID_MAIN_SAVE:
	  save_game(hWnd);
	  break;
	case ID_MAIN_START:
	  if (start_client())
	    {
	      Sleep(3000);
	      MessageBox(NULL,"Enter your name and click on connect in the Connect to Freeciv Server window and than click on ok here","Freeciv",MB_OK|MB_SETFOREGROUND );
	      SendPipeStr("start\n");
	    }
	  else
	    {
	      MessageBox(NULL,"Cannot start civclient","Freeciv",MB_OK);
	    }
	  break;
	case ID_MAIN_ABOUT:
	  DialogBox(hInst,MAKEINTRESOURCE(ID_ABOUT_DLG),NULL,About_Proc);
	case ID_MAIN_RET:
	  Edit_GetText(GetDlgItem(hWnd,ID_MAIN_SERVER_IN),inp_buf,99);
	  strcat(inp_buf,"\n");
	  WriteFile(stdinW,inp_buf,strlen(inp_buf),&ret_len,NULL);
	  break;
	}
      break;
    }
  return FALSE;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR lpCmdLine,
                     int nCmdShow)
{
  static SECURITY_ATTRIBUTES si;
  si.nLength=sizeof(si);
  si.bInheritHandle=TRUE;
  hInst=hInstance;
  if (!CreatePipe(&stdoutR,&stdoutW,&si,1024))
    return 0;
  if (!CreatePipe(&stdinR,&stdinW,&si,1024))
    return 0;
  if (!CreatePipe(&stderrR,&stderrW,&si,1024))
    return 0;
  server_proc.hThread=INVALID_HANDLE_VALUE;
  server_proc.hProcess=INVALID_HANDLE_VALUE;
  DialogBox(hInstance,MAKEINTRESOURCE(ID_MAIN_DLG),NULL,Dlg_Proc);
  terminate_server();
  return 0;
  
}
